<?php
/**
 * Customer processing order fba email
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/emails/customer-sent-to-fba-order.php.
 *
 * @see https://woocommerce.com/document/template-structure/
 * @package NeverSettle\WooCommerce-Amazon-Fulfillment\Emails
 * @version 1.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/*
 * @hooked WC_Emails::email_header() Output the email header
 */
do_action( 'woocommerce_email_header', $email_heading, $email ); ?>

<?php /* translators: %s: Customer first name */ ?>
<p><?php printf( esc_html__( 'Hi %s,', 'ns-fba-for-woocommerce' ), esc_html( $order->get_billing_first_name() ) ); ?></p>
<?php /* translators: %s: Order number */ ?>
<p><?php printf( esc_html__( 'Just to let you know &mdash; your order #%s is currently being processed at Amazon', 'ns-fba-for-woocommerce' ), esc_html( $order->get_order_number() ) ); ?></p>

<?php

/**
 * Show user-defined additional content - this is set in each email's settings.
 */
if ( $additional_content ) {
	echo wp_kses_post( wpautop( wptexturize( $additional_content ) ) );
}

/*
 * @hooked WC_Emails::email_footer() Output the email footer
 */
do_action( 'woocommerce_email_footer', $email );
