jQuery( function ( $ ) {
	function ns_fba_ddp_countdown( $element, $countDownText ) {
		var endTime = $element.attr('data-time') * 1000,
			now = Date.now();

		var distance = endTime - now;
		var days = Math.floor(distance / (1000 * 60 * 60 * 24));
		var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
		var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
		if (distance > 0) {
			if ( days > 0 ) {
				$element.html( days + " days " + hours + " hrs " +  minutes + " min ");
			} else if( hours > 0 ) {
				$element.html( hours + " hrs " +  minutes + " min ");
			} else {
				$element.html( minutes + " min ");
			}
			$countDownText.removeClass('ns-fba-hidden');
		}

		var timer = setInterval(function() {
			now = Date.now();
			distance = endTime - now;
			days = Math.floor(distance / (1000 * 60 * 60 * 24));
			hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
			minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
			if (distance > 0) {
				if ( days > 0 ) {
					$element.html( days + " days " + hours + " hrs " +  minutes + " min ");
				} else if( hours > 0 ) {
					$element.html( hours + " hrs " +  minutes + " min ");
				} else {
					$element.html( minutes + " min ");
				}
			}

			if (distance < 0) {
				clearInterval( timer );
				$element.html('');
				$countDownText.addClass('ns-fba-hidden');
			}
		}, 30 * 1000);
	}

	$(document).ready(function () {
		let ddp_form_to_submit = $('.ddp-product-zip.has-postal:not(.ddp-loaded)');
		if (ddp_form_to_submit.length) {
			ddp_form_to_submit.find('.ns-fba-ddp-lookup').click();
		}
	});

	$(document).on('click', '.ns-fba-ddp-lookup', function( e ) {
		e.preventDefault();
		var $label = $('.ddp-product-zip'),
			$button = $label.find('.ns-fba-ddp-lookup'),
			$sku = $button.attr('data-sku'),
			$container = $button.closest('.ddp'),
			ns_fba_product = window.ns_fba_product,
			variationId = '',
			$input = $container.find('.ns-fba-ddp-lookup-postal'),
			$response_message = $container.find('.ddp-response-message'),
			$product_offering = $container.find('.ddp-product-offering'),
			$preloader = $container.find('.ns-mcf-fba-preloader'),
			$countDownText = $product_offering.find('.ns-mcf-fba-ddp-information'),
			$countdown = $product_offering.find('.countdown'),
			$zipcode = $input.val(),
			$quantity = $('form.cart .qty').val();

		if ( ! $zipcode ) {
			$response_message.html( ns_fba_product.zip_error );
			return false;
		}

		$validZipcode = /(^\d{5}$)|(^\d{5}-\d{4}$)/.test( $zipcode );

		if ( ! $validZipcode ) {
			$response_message.html( ns_fba_product.zip_error );
			return false;
		}

		if ( ! $sku && $('.cart').find('.variation_id').length ) {
			variationId = $('.cart').find('.variation_id').val();
		}

		$response_message.html('');
		$label.addClass('ns-fba-hidden');
		$product_offering.addClass('ns-fba-hidden');
		$preloader.show();
		$.post(
			ns_fba_product.ajax_url,
			{ 'sku' : $sku, 'variation' : variationId, 'zipcode' : $zipcode, 'quantity' : $quantity, '_wpnonce' : ns_fba_product.nonce, 'action' : 'ns_fba_ddp_check' }
		).done( function( response ) {
			$preloader.hide();
			$product_offering.removeClass('ns-fba-hidden');
			if ( response.success === true && response.data.status ) {
				// Change content.
				$product_offering.removeClass('ns-fba-hidden');
				$label.addClass('ns-fba-hidden');
				$product_offering.html('<span class="ns-mcf-fba-ddp-delivery-text">'+response.data.message.text+'</span><br/><span class="ns-mcf-fba-ddp-information ns-fba-hidden">'+response.data.message.end_text+'</span> <span class="countdown ns-mcf-fba-ddp-time" data-time="'+response.data.message.end+'"></span><br/><span class="ns-mcf-ddp-delivery-details">'+response.data.message.zip_text+' <span class="underlined ns-mcf-fba-ddp-edit-link" data-sku="'+$sku+'">'+response.data.message.zip+'</span></span>');
				$countDownText = $product_offering.find('.ns-mcf-fba-ddp-information');
				$countdown = $product_offering.find('.countdown');
				$container.attr( 'data-zip', $zipcode ); // Set the zip for use in variations.
				$container.attr( 'data-sku', $sku );
				ns_fba_ddp_countdown( $countdown, $countDownText );

			} else {
				$label.removeClass('ns-fba-hidden');
				if ( response.data.message ) {
					$response_message.html(response.data.message);
				} else {
					$response_message.html(response.data);
				}
				
			}
		}).fail(function(xhr, status, error) {
			$preloader.hide();
			$label.removeClass('ns-fba-hidden');
			$product_offering.removeClass('ns-fba-hidden');
			$response_message.html(ns_fba_product.error);
		});

		return false;
	});

	// Edit zipcode
	$(document).on('click', '.ns-mcf-fba-ddp-edit-link', function() {
		if ( $(this).hasClass('opened') ) {
			$(this).removeClass('opened');
			$(this).closest('.ddp').find('.ddp-product-zip').addClass('ns-fba-hidden');
		} else{
			$(this).addClass('opened');
			$(this).closest('.ddp').find('.ddp-product-zip').removeClass('ns-fba-hidden');
		}

	});

	// On load, set offering and start countdown.
	if ( $('.ddp-product-offering').length ) {
		var $countdown = $('.ddp-product-offering').find('.countdown'),
			$countDownText = $('.ddp-product-offering').find('.ns-mcf-fba-ddp-information');
		ns_fba_ddp_countdown( $countdown, $countDownText );
	}

	// Variation change
	$( '.single_variation_wrap' ).on( 'show_variation', function( event, variation ) {
		var $container = $('.ddp'),
			ns_fba_product = window.ns_fba_product,
			$label = $container.find('.ddp-product-zip'),
			$zip = $container.attr('data-zip'),
			$response_message = $container.find('.ddp-response-message'),
			$product_offering = $container.find('.ddp-product-offering'),
			$preloader = $container.find('.ns-mcf-fba-preloader'),
			$countDownText = $product_offering.find('.ns-mcf-fba-ddp-information'),
			$countdown = $product_offering.find('.countdown'),
			$quantity = $('form.cart .qty').val(),
			$sku = variation.sku;

		if ( ! $zip ) {
			return;
		}
		$product_offering.addClass('ns-fba-hidden');
		$label.addClass('ns-fba-hidden');
		$preloader.show();
		$response_message.html('');
		$.post(
			ns_fba_product.ajax_url,
			{ 'sku' : $sku, 'zipcode' : $zip, 'quantity' : $quantity, '_wpnonce' : ns_fba_product.nonce, 'action' : 'ns_fba_ddp_check' }
		).done( function( response ) {
			$preloader.hide();
			$product_offering.removeClass('ns-fba-hidden');
			if ( response.success === true && response.data.status ) {
				// Change content.
				$label.addClass('ns-fba-hidden');
				$product_offering.html('<span class="ns-mcf-fba-ddp-delivery-text">'+response.data.message.text+'</span><br/><span class="ns-mcf-fba-ddp-information ns-fba-hidden">'+response.data.message.end_text+'</span> <span class="countdown ns-mcf-fba-ddp-time" data-time="'+response.data.message.end+'"></span><br/><span>'+response.data.message.zip_text+' <span class="underlined ns-mcf-fba-ddp-edit-link" data-sku="'+$sku+'">'+response.data.message.zip+'</span></span>');
				$countDownText = $product_offering.find('.ns-mcf-fba-ddp-information');
				$countdown = $product_offering.find('.countdown');
				$container.attr( 'data-sku', $sku );
				ns_fba_ddp_countdown( $countdown, $countDownText );

			} else {
				$label.removeClass('ns-fba-hidden');
				$response_message.html(response.message);
				$product_offering.html('');
			}
		}).fail(function(xhr, status, error) {
			$preloader.hide();
			$product_offering.removeClass('ns-fba-hidden');
			$response_message.html(ns_fba_product.error);
			$product_offering.html('');
		});
	});

	$( '.single_variation_wrap' ).on( 'hide_variation', function( event, variation ) {
		// Reset everything. No variation selected
	});

	// Handle quantity change.
	$(document).on('change', 'form.cart .qty', function() {
		var $quantity = $(this).val(),
			$container = $('.ddp'),
			ns_fba_product = window.ns_fba_product,
			$label = $container.find('.ddp-product-zip'),
			$zip = $container.attr('data-zip'),
			$response_message = $container.find('.ddp-response-message'),
			$product_offering = $container.find('.ddp-product-offering'),
			$preloader = $container.find('.ns-mcf-fba-preloader'),
			$countDownText = $product_offering.find('.ns-mcf-fba-ddp-information'),
			$countdown = $product_offering.find('.countdown'),
			$sku = $container.attr('data-sku');

		if ( ! $zip || !$sku ) {
			return;
		}
		$product_offering.addClass('ns-fba-hidden');
		$label.addClass('ns-fba-hidden');
		$preloader.show();
		$response_message.html('');
		$.post(
			ns_fba_product.ajax_url,
			{ 'sku' : $sku, 'zipcode' : $zip, 'quantity' : $quantity, '_wpnonce' : ns_fba_product.nonce, 'action' : 'ns_fba_ddp_check' }
		).done( function( response ) {
			$preloader.hide();
			$product_offering.removeClass('ns-fba-hidden');
			if ( response.success === true && response.data.status ) {
				// Change content.
				$product_offering.removeClass('ns-fba-hidden');
				$product_offering.html('<span class="ns-mcf-fba-ddp-delivery-text">'+response.data.message.text+'</span><br/><span class="ns-mcf-fba-ddp-information ns-fba-hidden">'+response.data.message.end_text+'</span> <span class="countdown ns-mcf-fba-ddp-time" data-time="'+response.data.message.end+'"></span><br/><span>'+response.data.message.zip_text+' <span class="underlined ns-mcf-fba-ddp-edit-link" data-sku="'+$sku+'">'+response.data.message.zip+'</span></span>');
				$countDownText = $product_offering.find('.ns-mcf-fba-ddp-information');
				$countdown = $product_offering.find('.countdown');
				$container.attr( 'data-sku', $sku );
				ns_fba_ddp_countdown( $countdown, $countDownText );

			} else {
				$label.removeClass('ns-fba-hidden');
				$response_message.html(response.message);
				$product_offering.html('');
			}
		}).fail(function(xhr, status, error) {
			$preloader.hide();
			$product_offering.removeClass('ns-fba-hidden');
			$label.removeClass('ns-fba-hidden');
			$response_message.html(ns_fba_product.error);
			$product_offering.html('');
		});
	});

});
